import 'package:clean_android_design/src/utils/validation/validator.dart';
import 'package:flutter/material.dart';

class FieldValidation<T> implements IValidation<T> {
  final String Function(T item) validateFunction;

  // From Field
  FocusNode _focusNode;
  void Function(String errorMessage) _onValidate;

  FieldValidation({
    @required Validator<T> validator,
    @required this.validateFunction,
  }) {
    validator.addChild(this);
  }

  void connectToField({
    @required Function(String errorMessage) onValidate,
    FocusNode focusNode,
  }) {
    _onValidate = onValidate;
    _focusNode = focusNode;
  }

  @override
  ValidationResult isValid(T item) {
    var errorMessage = validateFunction(item);
    _onValidate?.call(errorMessage);
    return ValidationResult(
      isValid: errorMessage == null,
      focusNode: _focusNode,
    );
  }
}
